/*
 * FILE: $Source: /u/chestnut/ezk/kitot/advanced-os/2/RCS/pipes.c,v $
 * HEADER: $Id: pipes.c,v 1.2 1992/02/11 13:56:39 ezk Exp ezk $
 * REVISION HISTORY:
 * $Log: pipes.c,v $
 * Revision 1.2  1992/02/11  13:56:39  ezk
 * FINAL VERSION (unless I get an extension...)
 *
 * Revision 1.1  1992/02/10  23:15:46  ezk
 * Initial revision
 *
 * 
 * Deal with shell pipes.
 * 
 * E6118y - Advanced Operating Systems.
 * Erez Zadok.
 * Columbia U.  Spring 1992.
 */

#include "process.h"


void start_pipeline(hcp, icp)
     proc_t *hcp, *icp;		/* head/internal process pointer */
{ int pfd[2], child_pid, pid, ppid, pgrp, tcgrp, status, retval;
  proc_t *tcp;

  signal(SIGINT, SIG_DFL);
  signal(SIGTSTP, SIG_DFL);

/*   fprintf(stderr,"In start_pipeline...\n"); */
  tcp = hcp;
  while (tcp != NULL_PROC) {
    if (tcp->next != NULL_PROC) {
/*       fprintf(stderr, "Creating a new PIPE tcp = %x\n", tcp); */
      if (pipe(pfd) < 0) {
	fprintf(stderr, "pipe failed in start_proc"); exit(errno);
      }
    }
    switch(child_pid = fork()) {
    case -1:			/* bad fork for some reason */
      PERROR("pipe fork failed"); free_pipeline(hcp); return; break;

    case 0:			/* CHILD */
/*       fprintf(stderr,"CHILD\n"); */
      if (tcp == hcp) {		/* pipeline head */
/* 	fprintf(stderr,"child pipeline head \n");   */
	close(1); dup(pfd[1]); close(pfd[0]); close(pfd[1]);
	execve(tcp->path, tcp->argv, sh_envp);
      }
      if (tcp->next == NULL_PROC) { /* pipeline tail */
/* 	fprintf(stderr,"default pipeline tail \n");   */
	close(0); dup(pfd[0]); close(pfd[0]); close(pfd[1]);
  	execve(tcp->path, tcp->argv, sh_envp);
      }
      break;

    default:			/* PARENT (The SHell) */
/*       fprintf(stderr,"PARENT\n"); */
      if (tcp == hcp) {
/* 	fprintf(stderr,"default pipeline head \n");   */
	close(pfd[1]);
	hcp->pid = child_pid;
      }				/* end of if (tcp == hcp) { ... */
      if (tcp->next == NULL_PROC) {
/* 	fprintf(stderr,"default pipeline tail \n");   */
	tcp->pid = child_pid;
	close(pfd[0]);
      }
      break;
    }				/* switch */
    tcp = tcp->next;
  }				/* while */
}				/* fxn */
