#include <stdio.h>

#include "pvm3.h"

#define MAXHOSTS 128

main (int argc, char **argv)
{
  int mytid;
  int status;

  int nhost;
  int narch;
  struct hostinfo *hostp;

  hostp = (struct hostinfo *) malloc (sizeof (struct hostinfo) * MAXHOSTS);

  /* PVM Startup */
  mytid = pvm_mytid();
  
  status = pvm_config(&nhost, &narch, &hostp);

  if (status) {
    perror("pvm_config");
    return 1;
  }

  fprintf(stdout, "hosts   =%d\n", nhost);
  fprintf(stdout, "formats =%d\n", narch);
  fprintf(stdout, "\n");

  {
    int i;

      fprintf(stdout,
	      "%-10s  %-25s  %10s  %5s  %5s\n",
	      "TaskID",
	      "Name",
	      "ARCH",
	      "MTU",
	      "Rel Speed" );

    for (i=0; i<nhost; i++)
      fprintf(stdout,
	      "%8x  %-25s  %10s  %5d  %5d\n",
	      hostp[i].hi_tid,
	      hostp[i].hi_name,
	      hostp[i].hi_arch,
	      hostp[i].hi_mtu,
	      hostp[i].hi_speed );
  }

  /* PVM Shutdown */
  pvm_exit();
}
